#!/usr/bin/python2.7

#############################################################################
# Copyright (C) Labomedia May 2012
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franproplin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#############################################################################

from time import time, sleep

try:
    from twisted.internet import reactor
    from txosc import async, dispatch, osc
except:
    print "You must install python-txosc and maybe python-twisted"

print "Relay\n"
print "MultiPass For Freedom\n\n"

# TODO check if python-twisted is dependency of txosc

host_multicast = "224.0.0.11"
port_multicast = 18888
host_local = "127.0.0.1"
port_out = 8000
port_in = 9000
t1 = time()

'''Don't forget to add handler for every message from multicast to udp
otherwise they are not retransmit.
With "/*", all messsage do loop'''
message_send_from_multicast_to_udp = ["/for_all_players", "/reset"]

global udp_receiver
global udp_sender
global multicast_sender
global multicast_reicever

def main():
    # Set instance
    global udp_receiver
    global udp_sender
    global multicast_sender
    global multicast_reicever
    udp_receiver = UDPReceiver(port_in)
    udp_sender = UDPSender(port_out)
    multicast_sender = UDPMulticastSender(port_multicast)
    multicast_reicever = UDPMulticastReceiver(port_multicast)
    reactor.run()

def send_with_multicast_handler(message, address):
    # send the same message to multicast
    multicast_sender.send_message(message)

class UDPReceiver(object):
    def __init__(self, port):
        self.port = port
        self.receiver = dispatch.Receiver()
        self._server_port = reactor.listenUDP(self.port, async.DatagramServerProtocol(self.receiver))
        print("Listening udp on: %s : %s" % (host_local, self.port))
        # quit
        self.receiver.addCallback("/quit", self.quit_handler)
        # handler for all usefull data from a player
        self.receiver.addCallback("/*", send_with_multicast_handler)

    def quit_handler(self, message, address):
        print("Quit : Got %s from %s" % (message, address))
        reactor.stop()
        print("Goodbye.")
        try:
            exit(0)
        except:
            pass

class UDPMulticastSender(object):
    def __init__(self, port, host=host_multicast):
        self.port = port
        self.host = host
        self.client = async.DatagramClientProtocol()
        self._client_port = reactor.listenUDP(0, self.client)
        print("Sending multicast on: %s : %s" % (self.host, self.port))

    def send_message(self, message):
        self.client.send(message, (self.host, self.port))

def send_with_udp_handler(message, address):
    # send the same message with udp to blender
    udp_sender.send_message(message)
    global t1
    if time() - t1 > 1:
        print message
        t1 = time()

class UDPMulticastReceiver(object):
    def __init__(self, port):
        self.port = port
        self.receiver = dispatch.Receiver()
        self._server_port = reactor.listenMulticast(self.port, async.MulticastDatagramServerProtocol(self.receiver, host_multicast), listenMultiple=True)
        print("Listening multicast on: %s : %s" % (host_multicast, self.port))
        # if "/*" return received message from blender to blender
        for item in message_send_from_multicast_to_udp:
            self.receiver.addCallback(item, send_with_udp_handler)

class UDPSender(object):
    def __init__(self, port, host=host_local):
        self.port = port
        self.host = host
        self.client = async.DatagramClientProtocol()
        self._client_port = reactor.listenUDP(0, self.client)
        print("Sending multicast on: %s : %s" % (self.host, self.port))

    def send_message(self, message):
        self.client.send(message, (self.host, self.port))

main()
